package functionaljavatest;

import fj.F2;
import java.awt.Point;

public class Pnt {  
    public double x;
    public double y;
    
    public Pnt( double x, double y ) {
        this.x = x;
        this.y = y;
    }

    public Pnt(Point point) {
        x = point.x;
        y = point.y;
    }
    
    public Pnt add(double dx, double dy) {
        return new Pnt(x+dx,y+dy);
    }     
    
    public Vec diff( Pnt other ) {
        return new Vec( x-other.x, y-other.y );
    }
    
    public double distanceTo( Pnt other ) {
        double dx = other.x - x;
        double dy = other.y - y;
        return Math.sqrt( dx*dx + dy*dy );
    }
       
    public static final F2<Pnt, Vec, Pnt> padd = new F2<Pnt, Vec, Pnt>() {
        @Override
        public Pnt f(Pnt a, Vec b) {
            return new Pnt(a.x+b.x,a.y+b.y);
        }
    };

    public Pnt copy() {
        return new Pnt(x,y);
    }

    public static Pnt random(double maxX, double maxY) {
        return new Pnt( maxX*Math.random(), maxY*Math.random() );
    }    
}